diff --git a/packages/visualgst/Widget/Text/GtkReplaceWidget.st b/packages/visualgst/Widget/Text/GtkReplaceWidget.st
new file mode 100644
index 0000000..e0971fd
--- /dev/null
+++ b/packages/visualgst/Widget/Text/GtkReplaceWidget.st
@@ -0,0 +1,103 @@
+"======================================================================
+|
+| GtkReplaceWidget class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkFindWidget subclass: GtkReplaceWidget [
+    | replaceWidget replaceButton replaceAllButton |
+
+    replaceEntry [
+	<category: 'user interface'>
+
+	^ replaceWidget := GTK.GtkEntry new
+			    connectSignal: 'activate' to: self selector: #replacePressed;
+			    yourself
+    ]
+
+    replaceButton [
+        <category: 'user interface'>
+
+	^ replaceButton := (GTK.GtkButton newWithLabel: 'Replace')
+			    connectSignal: 'clicked' to: self selector: #replacePressed;
+			    yourself
+    ]
+
+    replaceAllButton [
+        <category: 'user interface'>
+
+	^ replaceAllButton := (GTK.GtkButton newWithLabel: 'Replace All')
+			    connectSignal: 'clicked' to: self selector: #replaceAllPressed;
+			    yourself
+    ]
+
+    replaceBox [
+        <category: 'user interface'>
+
+	| hBox |
+	^ (GTK.GtkHBox new: false spacing: 3)
+            packStart: (Label text: 'Replace with:') mainWidget expand: false fill: false padding: 2;
+            packStart: self replaceEntry expand: false fill: false padding: 15;
+	    packStart: self replaceButton expand: false fill: false padding: 15;
+            packStart: self replaceAllButton expand: false fill: false padding: 15;
+	    yourself
+    ]
+
+    buildWidget [
+	<category: 'user interface'>
+
+	^ super buildWidget
+	    packStart: self replaceBox expand: false fill: false padding: 0;
+	    yourself
+
+    ]
+
+    replacePressed [
+	<category: 'replace events'>
+
+	| i iter |
+	self keyPressed.
+	textWidget hasSelection ifFalse: [ ^ self ].
+	i := textWidget iterOfSelectedText first getOffset.
+	textWidget cut.
+	iter := textWidget buffer getIterAtOffset: i.
+	textWidget buffer insertInteractive: iter text: replaceWidget getText len: replaceWidget getText size defaultEditable: true
+    ]
+
+    replaceAllPressed [
+        <category: 'replace events'>
+
+	"matching doesn't work now"
+	textWidget replace: entry getText by: replaceWidget getText
+    ]
+]
+
diff --git a/packages/visualgst/Widget/Text/GtkSaveTextWidget.st b/packages/visualgst/Widget/Text/GtkSaveTextWidget.st
new file mode 100644
index 0000000..bc823c2
--- /dev/null
+++ b/packages/visualgst/Widget/Text/GtkSaveTextWidget.st
@@ -0,0 +1,89 @@
+"======================================================================
+|
+| GtkSaveTestWidget class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkTextPluginWidget subclass: GtkSaveTextWidget [ 
+    | label |
+
+    buildDropButton [
+	<category: 'user interface'>
+
+        ^(GTK.GtkButton newWithLabel: 'Drop')
+	    connectSignal: 'pressed' to: self selector: #cancel;
+            yourself
+    ]
+
+    buildAcceptButton [
+        <category: 'user interface'>
+
+        ^(GTK.GtkButton newWithLabel: 'Accept')
+	    connectSignal: 'pressed' to: self selector: #acceptIt;
+            yourself
+    ]
+
+    hBox [
+	<category: 'user interface'>
+
+	^ super hBox
+	    packStart: (label := Label text: '') mainWidget expand: false fill: false padding: 2;
+	    packEnd: self buildAcceptButton expand: false fill: false padding: 0; 
+	    packEnd: self buildDropButton expand: false fill: false padding: 0;
+	    yourself
+    ]
+
+    label: aString [
+	<category: 'state'>
+
+	label text: aString
+    ]
+
+    grabFocus [
+	<category: 'focus'>
+
+	closeButton grabFocus
+    ]
+
+    acceptIt [
+	<category: 'events'>
+
+	textWidget acceptIt
+    ]
+
+    cancel [
+	<category: 'events'>
+
+	textWidget cancel
+    ]
+]
+
diff --git a/packages/visualgst/Widget/Text/GtkSourceCodeWidget.st b/packages/visualgst/Widget/Text/GtkSourceCodeWidget.st
new file mode 100644
index 0000000..7d878c5
--- /dev/null
+++ b/packages/visualgst/Widget/Text/GtkSourceCodeWidget.st
@@ -0,0 +1,289 @@
+"======================================================================
+|
+| GtkSourceCodeWidget class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkTextWidget subclass: GtkSourceCodeWidget [
+    | browser codeText saveWidget |
+
+    initialize [
+	<category: 'initialization'>
+
+	super initialize.
+	self initializeHighlighter
+    ]
+
+    initializeHighlighter [
+	<category: 'initialization'>
+
+	(self buffer)
+	    createTag: #classVar varargs: #('foreground' 'cyan4' nil);
+	    createTag: #globalVar varargs: #('foreground' 'cyan4' nil);
+	    createTag: #poolVar varargs: #('foreground' 'cyan4' nil);
+	    createTag: #undeclaredVar varargs: #('foreground' 'red' nil);
+	    createTag: #instanceVar varargs: #('foreground' 'black' nil);
+	    createTag: #argumentVar varargs: #('foreground' 'black' nil);
+	    createTag: #temporary varargs: #('foreground' 'black' nil);
+	    createTag: #specialId varargs: #('foreground' 'grey50' nil);
+	    createTag: #literal varargs: #('foreground' 'grey50' nil);
+	    createTag: #temporaries varargs: #('foreground' 'magenta' nil);
+	    createTag: #methodHeader varargs: #('foreground' 'magenta' nil);
+	    createTag: #primitive varargs: #('foreground' 'magenta' nil);
+	    createTag: #arguments varargs: #('foreground' 'magenta' nil);
+	    createTag: #special varargs: #('foreground' 'magenta' nil);
+	    createTag: #unaryMsg varargs: #('foreground' 'magenta4' nil);
+	    createTag: #binaryMsg varargs: #('foreground' 'chocolate4' nil);
+	    createTag: #keywordMsg varargs: #('foreground' 'NavyBlue' nil);
+	    createTag: #comment varargs: #('foreground' 'SpringGreen4' nil)
+    ]
+
+    sourceCode [
+	<category: 'accessing'>
+
+	^ self buffer text
+    ]
+
+    source: aSource [
+	<category: 'accessing'>
+
+        | string |
+        string := aSource source.
+	self emptyStack.
+	self codeText: string. 
+	self buffer setText: self codeText.
+	aSource parser == STInST.RBBracketedMethodParser ifTrue: [
+            self parseSource: string ifParsed: [ :node | SyntaxHighlighter highlight: node in: self buffer ] ]
+    ]
+
+    parseSource: aString ifParsed: aOneArgBlock [
+	<category: 'parsing'>
+
+	| node parser |
+	parser := STInST.RBBracketedMethodParser new
+                    errorBlock: [ :string :pos | ^ self ];
+                    initializeParserWith: aString type: #'on:errorBlock:';
+                    yourself.
+        [ node := parser parseMethod ] on: Error do: [ :ex | stderr print: ex messageText; nl; print: ex signalingContext; nl; nl. ^ self ].
+	^ aOneArgBlock value: node
+    ]
+
+    connectSignals [
+        <category: 'initialization'>
+
+	super connectSignals.
+        self
+            connectToWhenPopupMenu: (TextMenus on: self).
+        (self buffer)
+	    connectSignal: 'changed' to: self selector: #'changed' userData: nil
+    ]
+
+    buildWidget [
+	<category: 'user interface'>
+
+        | root |
+        super buildWidget.
+        root := child.
+        child := GTK.GtkFrame new: 'Code'.
+        child add: root
+    ]
+
+    changed [
+	<category: 'buffer changed'>
+
+	| node text |
+	(text := self buffer text) = '' ifTrue: [ ^ self ].
+	self parseSource: text ifParsed: [ :node | SyntaxHighlighter highlight: node in: self buffer ]
+    ]
+
+    state [
+	<category: 'state'>
+
+        ^browser state
+    ]
+
+    packPlugins [
+	<category: 'user interface'>
+        child
+            packStart: ((saveWidget := GtkSaveTextWidget on: self)  mainWidget) expand: false fill: false padding: 0.
+        super packPlugins
+    ]
+
+    showSave: aString [
+        <category: 'user interface'>
+
+        saveWidget label: aString.
+	saveWidget showAll
+    ]
+
+    postInitialize [
+        <category: 'initialize'>
+
+        super postInitialize.
+        saveWidget mainWidget hide
+    ]
+
+    acceptIt [
+	<category: 'buffer events'>
+
+	browser acceptIt
+    ]
+
+    compileError: aString line: line [
+	<category: 'class event'>
+
+        self showSave: aString
+    ]
+
+    cancel [
+	<category: 'buffer events'>
+
+	self clearUndo.
+        saveWidget hideAll.
+	self buffer setText: self codeText
+    ]
+
+    doIt [
+        <category: 'smalltalk event'>
+
+        ^ browser doIt
+    ]
+
+    debugIt [
+        <category: 'smalltalk event'>
+
+        ^ browser debugIt
+    ]
+
+    inspectIt [
+        <category: 'smalltalk event'>
+
+        ^ browser inspectIt
+    ]
+
+    printIt [
+        <category: 'smalltalk event'>
+
+        ^ browser printIt
+    ]
+
+    codeSaved [
+	<category: 'accessing'>
+
+        saveWidget hideAll.
+	self textSaved
+    ]
+
+    codeText [
+	<category: 'accessing'>
+
+	^ codeText ifNil: [ codeText := '' ]
+    ]
+
+    codeText: aString [
+	<category: 'accessing'>
+
+	codeText := aString copy
+    ]
+
+    browser: aGtkClassBrowserWidget [
+	<category: 'accessing'>
+
+	browser := aGtkClassBrowserWidget
+    ]
+
+    selectedMethodSymbol [
+	<category: 'method'>
+
+        | iters stream parser node |
+	stream := self sourceCode readStream.
+        iters := self buffer getSelectionBounds.
+        parser := STInST.RBBracketedMethodParser new.
+        parser errorBlock: [:message :position | ^nil].
+        parser 
+            scanner: (parser scannerClass on: stream errorBlock: parser errorBlock).
+        node := parser parseMethod body.
+        node := node bestNodeFor:
+	    (iters first getOffset + 1 to: iters second getOffset + 1).
+        [node isNil ifTrue: [^nil].
+	node isMessage] whileFalse: 
+                [node := node parent].
+        ^node selector
+    ]
+
+    sourceCodeWidgetHasFocus [
+	<category: 'browse'>
+
+	^ true
+    ]
+
+    browserHasFocus [
+	<category: 'browse'>
+
+	^ false
+    ]
+
+    launcher [
+	<category: 'browse'>
+
+	^browser ifNotNil: [ browser launcher ]
+    ]
+
+    browseSenders [
+	<category: 'browse'>
+
+	OpenSenderCommand on: self
+    ]
+
+    browseImplementors [
+	<category: 'browse'>
+
+	^ browser ifNotNil: [ browser launcher ]
+    ]
+
+    appendTag: aSymbol description: anArray [
+	<category: 'text buffer'>
+
+	self buffer
+            createTag: aSymbol varargs: anArray
+    ]
+
+    applyTag: aSymbol forLine: anInteger [
+	<category: 'text buffer'>
+
+	| start end |
+	start := self buffer getIterAtLine: anInteger - 1.
+	end := self buffer getIterAtLine: anInteger.
+	self buffer applyTagByName: aSymbol start: start end: end
+    ]
+]
+
diff --git a/packages/visualgst/Widget/Text/GtkTextPluginWidget.st b/packages/visualgst/Widget/Text/GtkTextPluginWidget.st
new file mode 100644
index 0000000..d0438c3
--- /dev/null
+++ b/packages/visualgst/Widget/Text/GtkTextPluginWidget.st
@@ -0,0 +1,90 @@
+"======================================================================
+|
+| GtkTextPluginWidget class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkConcreteWidget subclass: GtkTextPluginWidget [
+    | textWidget closeButton |
+
+    GtkTextPluginWidget class >> on: aTextWidget [
+	<category: 'instance creation'>
+
+	^ self new
+	    initialize;
+	    textWidget: aTextWidget;
+	    yourself
+    ]
+
+    initialize [
+	<category: 'initialize'>
+
+	self mainWidget: self buildWidget
+    ]
+
+    buildCloseButton [
+        <category: 'user interface'>
+
+	^(closeButton := GTK.GtkButton closeButton)
+	    connectSignal: 'pressed' to: self selector: #'close' userData: nil;
+	    yourself
+    ]
+
+    hBox [
+        <category: 'user interface'>
+
+        ^ (GTK.GtkHBox new: false spacing: 3)
+            packEnd: self buildCloseButton expand: false fill: false padding: 0;
+            yourself
+    ]
+
+    buildWidget [
+	<category: 'user interface'>
+
+	^ (GTK.GtkVBox new: false spacing: 3)
+	    packStart: self hBox expand: false fill: false padding: 0;
+	    yourself
+    ]
+
+    close [
+	<category: 'events'>
+
+	self mainWidget hide
+    ]
+
+    textWidget: aTextWidget [
+	<category: 'accessing'>
+
+	textWidget := aTextWidget
+    ]
+]
+
diff --git a/packages/visualgst/Widget/Text/GtkTextWidget.st b/packages/visualgst/Widget/Text/GtkTextWidget.st
new file mode 100644
index 0000000..b08a6ef
--- /dev/null
+++ b/packages/visualgst/Widget/Text/GtkTextWidget.st
@@ -0,0 +1,433 @@
+"======================================================================
+|
+| GtkTextWidget class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Widget subclass: GtkTextWidget [
+
+    | findWidget replaceWidget textWidget userAction undoStack lastCommand cut textSaved lastSavedCommand |
+
+    GtkTextWidget class >> newWithBuffer: aGtkTextBuffer [
+        <category: 'instance creation'>
+
+	^ self new
+	    initialize;
+	    buffer: aGtkTextBuffer;
+	    yourself
+    ]
+
+    connectToWhenPopupMenu: aMenu [
+        <category: 'button event'>
+        popupMenu := aMenu.
+	textWidget
+	    connectSignal: 'populate-popup' to: self selector: #'popupMenuOn:menu:'
+    ]
+
+    popupMenuOn: aWidget menu: aGtkMenu [
+        <category: 'button event'>
+        aGtkMenu append: (GTK.GtkMenuItem new show; yourself).
+        popupMenu appendTo: aGtkMenu
+    ]
+
+    connectSignals [
+	<category: 'initialization'>
+
+	textWidget
+	    connectSignal: 'paste-clipboard' to: self selector: #pasteFromClipboard;
+            connectSignal: 'cut-clipboard' to: self selector: #cutFromClipboard.
+
+	(self buffer)
+            connectSignal: 'begin-user-action' to: self selector: #'beginUserAction';
+            connectSignal: 'end-user-action' to: self selector: #'endUserAction';
+            connectSignal: 'insert-text' to: self selector: #'insert:at:text:size:';
+            connectSignal: 'delete-range' to: self selector: #'delete:from:to:'
+    ]
+
+    initialize [
+        <category: 'initialization'>
+
+	textSaved := false.
+        cut := userAction := false.
+        undoStack := (UndoStack new)
+                        initialize;
+                        yourself.
+	self 
+	    buildWidget;
+	    connectSignals.
+	
+    ]
+
+    postInitialize [
+        <category: 'initialize'>
+
+        findWidget mainWidget hide.
+        replaceWidget mainWidget hide.
+    ]
+
+    buildWidget [
+	<category: 'user interface'>
+
+	textWidget := GTK.GtkTextView new.
+        child := GTK.GtkVBox new: false spacing: 3.
+        self packPlugins.
+        child packStart: (GTK.GtkScrolledWindow withChild: textWidget) expand: true fill: true padding: 0.
+    ]
+
+    packPlugins [
+	<category: 'user interface'>
+
+        child
+            packEnd: ((findWidget := GtkFindWidget on: self) mainWidget) expand: false fill: false padding: 0;
+            packEnd: ((replaceWidget := GtkReplaceWidget on: self)  mainWidget) expand: false fill: false padding: 0
+    ]
+
+    beginUserAction [
+        <category: 'buffer events'>
+
+        userAction := true
+    ]
+
+    endUserAction [
+        <category: 'buffer events'>
+
+        userAction := false
+    ]
+
+    pasteFromClipboard [
+        <category: 'clipboard events'>
+
+        lastCommand := nil
+    ]
+
+    cutFromClipboard [
+        <category: 'clipboard events'>
+
+        cut := true and: [ self buffer getHasSelection ].
+        cut ifTrue: [ lastCommand := nil ]
+    ]
+
+    insert: aGtkTextBuffer at: aCObject text: aString size: anInteger [
+        <category: 'buffer events'>
+
+        | gtkTextIter offset |
+        userAction ifFalse: [ ^ self ].
+        gtkTextIter := GTK.GtkTextIter address: aCObject address.
+	(aString size = 1 and: [ aString first = Character lf]) 
+	    ifTrue: [ lastCommand := InsertTextCommand insert: aString at: gtkTextIter getOffset on: self buffer.
+                undoStack push: lastCommand.
+		lastCommand := nil.
+		^ self ].
+        (lastCommand isNil or: [ aString size > 1 ])
+            ifTrue: [ lastCommand := InsertTextCommand insert: aString at: gtkTextIter getOffset on: self buffer.
+                undoStack push: lastCommand.
+                aString size > 1 ifTrue: [ lastCommand := nil ].
+                ^ self ].
+        ((gtkTextIter getOffset = (lastCommand offset + lastCommand size)) and: [ lastCommand isInsertCommand ])
+            ifTrue: [ lastCommand string: (lastCommand string, aString).
+                ^ self ].
+        lastCommand := InsertTextCommand insert: aString at: gtkTextIter getOffset on: self buffer.
+        undoStack push: lastCommand.
+    ]
+
+    delete: aGtkTextBuffer from: aStartCObject to: anEndCObject [
+        <category: 'buffer events'>
+
+        | startIter endIter text |
+        userAction ifFalse: [ cut := false. ^ self ].
+        startIter := GTK.GtkTextIter address: aStartCObject address.
+        endIter := GTK.GtkTextIter address: anEndCObject address.
+        text := self buffer getText: startIter end: endIter includeHiddenChars: false.
+        (lastCommand isNil or: [ cut ])
+            ifTrue: [ lastCommand := DeleteTextCommand from: startIter getOffset to: endIter getOffset text: text on: self buffer.
+                undoStack push: lastCommand.
+                cut ifTrue: [ lastCommand := nil ].
+                cut := false.
+                ^ self ].
+        ((startIter getOffset = (lastCommand offset - lastCommand size)) and: [ lastCommand isDeleteCommand ])
+            ifTrue: [ lastCommand string: (text, lastCommand string).
+                ^ self ].
+        lastCommand := DeleteTextCommand from: startIter getOffset to: endIter getOffset text: text on: self buffer.
+        undoStack push: lastCommand.
+    ]
+
+    hasChanged [
+        <category: 'testing'>
+
+        ^ textSaved not and: [ undoStack hasUndo ]
+    ]
+
+    hasUndo [
+	<category: 'buffer events'>
+
+	^ undoStack hasUndo
+    ]
+
+    clearUndo [
+	<category: 'buffer events'>
+
+        textSaved := false.
+        lastSavedCommand := nil.
+	undoStack clear
+    ]
+
+    undo [
+        <category: 'buffer events'>
+
+        textSaved := self lastUndoCommand == lastSavedCommand.
+        undoStack undo.
+        lastCommand := nil.
+    ]
+
+    redo [
+        <category: 'buffer events'>
+
+        undoStack redo.
+        lastCommand := nil.
+        textSaved := self lastUndoCommand == lastSavedCommand.
+    ]
+
+    emptyStack [
+	<category: 'stack events'>
+
+	undoStack clear
+    ]
+
+    lastUndoCommand [
+	<category: 'buffer events'>
+
+	^ undoStack lastUndoCommand
+    ]
+
+    textSaved [
+        <category: 'accessing'>
+
+        textSaved := true.
+        lastCommand := nil.
+        lastSavedCommand := undoStack lastUndoCommand
+    ]
+
+    buffer [
+	<category: 'accessing'>
+
+	^ textWidget getBuffer
+    ]
+
+    buffer: aGtkTextBuffer [
+	<category: 'accessing'>
+
+	textWidget setBuffer: aGtkTextBuffer
+    ]
+
+    showFind [
+        <category: 'user interface'>
+
+        replaceWidget hideAll.
+	findWidget showAll; grabFocus
+    ]
+
+    showReplace [
+        <category: 'user interface'>
+
+        findWidget hideAll.
+	replaceWidget showAll; grabFocus
+    ]
+
+    replace: aSearchString by: aReplaceString [
+        <category: 'text editing'>
+
+	lastCommand := ReplaceTextCommand replace: aSearchString by: aReplaceString on: self buffer.
+        undoStack push: lastCommand.
+        lastCommand := nil
+    ]
+
+    copy [
+        <category: 'text editing'>
+
+        textWidget signalEmitByName: 'copy-clipboard' args: {}
+    ]
+
+    cut [
+        <category: 'text editing'>
+
+        textWidget signalEmitByName: 'cut-clipboard' args: {}
+    ]
+
+    paste [
+        <category: 'text editing'>
+
+        textWidget signalEmitByName: 'paste-clipboard' args: {}.
+    ]
+
+    selectAll [
+        <category: 'text editing'>
+
+        textWidget signalEmitByName: 'select-all' args: {true}.
+    ]
+
+    iterOfSelectedText [
+        <category: 'text accessing'>
+
+        ^ textWidget getBuffer iterOfSelectedText
+    ]
+
+    hasSelection [
+        <category: 'text accessing'>
+
+	^ self buffer getHasSelection
+    ]
+
+    selectedMethodSymbol [
+	<category: 'accessing'>
+
+        ^ STInST.RBParser selectedSymbol: self selectedText
+    ]
+
+    selectedText [
+        <category: 'text accessing'>
+
+        ^ self buffer selectedText
+    ]
+
+    clear [
+        <category: 'updating'>
+
+        self text: ''
+    ]
+
+    text [
+        <category: 'text accessing'>
+
+        ^ self buffer text
+    ]
+
+    text: aString [
+        <category: 'text accessing'>
+
+        self buffer setText: aString
+    ]
+
+    textview [
+	<category: 'text widget'>
+
+	^ textWidget
+    ]
+
+    cursorPosition [
+	<category: 'accessing'>
+
+	^ self buffer propertiesAt: 'cursor-position'
+    ]
+
+    cursorPosition: anInteger [
+        <category: 'accessing'>
+
+    ]
+
+    selectRange: aStartInt bound: anEndInt [
+	<category: 'accessing'>
+
+	| start end |
+	start := self buffer getIterAtOffset: aStartInt.
+        end := self buffer getIterAtOffset: anEndInt.
+	self buffer selectRange: start bound: end
+    ]
+
+    centerViewAtLine: anInteger [
+        <category: 'view'>
+
+        | mark iter |
+        iter := self buffer getIterAtLine: anInteger.
+        mark := GTK.GtkTextMark new: nil leftGravity: false.
+        self buffer addMark: mark where: iter.
+        textWidget scrollMarkOnscreen: mark.
+    ]
+
+    beforeEvaluation [
+        <category: 'smalltalk event'>
+    ]
+
+    afterEvaluation [
+        <category: 'smalltalk event'>
+    ]
+
+    doWithoutForkIt: object [
+        <category: 'smalltalk event'>
+
+        | result |
+        self beforeEvaluation.
+        result := Behavior
+                    evaluate: self buffer selectedText
+                    to: object
+                    ifError: [ :fname :lineNo :errorString | self error: errorString ].
+        self afterEvaluation.
+        ^ result
+    ]
+
+    doIt: object [
+        <category: 'smalltalk event'>
+
+	TaskQueue uniqueInstance add: [ self doWithoutForkIt: object ]
+    ]
+
+    debugIt: object [
+        <category: 'smalltalk event'>
+
+        self beforeEvaluation.
+        object class
+            compile: ('Doit [ ^ [ ', self selectedText , ' ] value ]')
+            ifError:  [ :fname :lineNo :errorString |
+                self error: errorString ].
+        (GtkDebugger open)
+            doItProcess: [ object perform: #Doit ] newProcess
+    ]
+
+    inspectIt: object [
+        <category: 'smalltalk event'>
+
+        TaskQueue uniqueInstance add: [ GtkInspector openOn: (self doWithoutForkIt: object) ]
+    ]
+
+    printIt: object [
+        <category: 'smalltalk event'>
+
+        TaskQueue uniqueInstance add:
+            [ | iter start end result |
+              iter := self buffer iterOfSelectedText second.
+              result := ' ', ((self doWithoutForkIt: object) displayString), ' '.
+              self buffer insertInteractive: iter text: result len: result size defaultEditable: true.
+              start := self buffer getIterAtOffset: (iter getOffset - result size).
+              end := self buffer getIterAtOffset: (iter getOffset).
+              self buffer selectRange: start bound: end ]
+    ]
+]
+
